/*--
  Description:

  Class wishGui extends WishIntfc to build a GUI that
  can be used to draw rectangles/ovals/text. It also has the methods that
  read in input form the GUI. The function processWishReq recognizes the 
  buttons form the GUI and acts accordingly

  Last Modified: 18 Jan, 1999 by Prakash Gopalakrishnan (prakashg@ece.cmu.edu)

  --*/

#include <signal.h>
#include <sys/wait.h>
#include <iostream.h>
#include "WishIntfc.hxx"

class wishGui : public WishIntfc {

public:

  void Initialize();

  // read from file and create canvas with given size
  int Start(char* tcl_fname);

  int End(void); //ends the wish shell and Kills the process

  int ProcessWishReq();
  // reads in the stdout from wish 

  // this does the mirroring on x-axis
  int drawRectangle(int minx, int miny, int maxx, int maxy, char* options);
  int drawLine(int X1, int Y1, int X2, int Y2, char* options);
  int drawOval(int minx, int miny, int maxx, int maxy, char* options);
  int drawText(int x, int y, char* text, char* options);
  int clearAll(void); // deletes all objects from canvas
  int sendRawCommand(char *);
  int rescale();
};
